# -*- coding: utf-8 -*-
# @Author: wangkun
# @Time: 2023/3/16
import json
import os
import random
import shutil
import sys
import time
from hashlib import md5
import requests
import urllib3

from common.mq import MQ
sys.path.append(os.getcwd())
from common.common import Common
from common.feishu import Feishu
from common.publish import Publish
from common.scheduling_db import MysqlHelper
from common.public import get_config_from_mysql, download_rule
proxies = {"http": None, "https": None}


class XiaoniangaoplayScheduling:
    platform = "小年糕"
    words = "abcdefghijklmnopqrstuvwxyz0123456789"
    uid_token_dict = {
        "uid": f"""{"".join(random.sample(words, 8))}-{"".join(random.sample(words, 4))}-{"".join(random.sample(words, 4))}-{"".join(random.sample(words, 4))}-{"".join(random.sample(words, 12))}""",
        "token": "".join(random.sample(words, 32))}

    # 获取列表
    @classmethod
    def get_videoList(cls, log_type, crawler, rule_dict, our_uid, env):
        mq = MQ(topic_name="topic_crawler_etl_" + env)
        # uid_token_dict = cls.uid_token_dict
        for page in range(1, 101):
            try:
                Common.logger(log_type, crawler).info(f"正在抓取第{page}页")
                Common.logging(log_type, crawler, env, f"正在抓取第{page}页")
                url = "https://kapi-xng-app.xiaoniangao.cn/v2/trends/recommend"
                payload = "{\"topic_name\":\"recommend\",\"ext\":{\"current_item\":0,\"items\":[]},\"tag_id\":0,\"refresh\":false,\"share_width\":300,\"share_height\":240,\"staggered_style\":0,\"qs\":\"imageMogr2\\/gravity\\/center\\/rotate\\/$\\/thumbnail\\/!750x500r\\/interlace\\/1\\/format\\/jpg\",\"topic_id\":2,\"h_qs\":\"imageMogr2\\/gravity\\/center\\/rotate\\/$\\/thumbnail\\/!80x80r\\/interlace\\/1\\/format\\/jpg\",\"log\":{\"net\":\"wifi\",\"product\":\"xng\",\"uid\":\"2F310D09-5E32-5985-8644-3BCB6920E76F\",\"brand\":\"iPad\",\"page\":\"\",\"session_id\":\"71C77648-3224-4083-894C-B6282131F286\",\"resolution\":\"750*1334\",\"pf\":\"4\",\"app_version\":\"1.22.5\",\"device\":\"iPad Pro (12.9-inch) (3rd generation)\",\"os_version\":\"15.7\",\"idfa\":\"\",\"channel\":\"ios_app_store\"},\"token\":\"\"}"
                headers = {
                    'Host': 'kapi-xng-app.xiaoniangao.cn',
                    'content-type': 'application/json; charset=utf-8',
                    'accept': 'application/json',
                    'authorization': 'PsrUTBCQ5G7UVZdgx+JxymPHcKU=',
                    'verb': 'POST',
                    'content-md5': '08fa0e6bf725fd6ef83c16d2ceb8a544',
                    'x-b3-traceid': '45a6c5b4c471eecc',
                    'accept-language': 'zh-Hans-CN;q=1.0',
                    'date': 'Mon, 19 Jun 2023 09:47:40 GMT',
                    'x-token-id': '',
                    'x-signaturemethod': 'hmac-sha1',
                    'user-agent': 'xngapp/1.22.5 (cn.xiaoniangao.xngapp; build:157; iOS 15.7.0) Alamofire/5.2.2'
                }
                urllib3.disable_warnings()
                r = requests.post(url=url, headers=headers, data=payload, proxies=proxies, verify=False)
                if "data" not in r.text or r.status_code != 200:
                    Common.logger(log_type, crawler).warning(f"get_videoList:{r.text}\n")
                    Common.logging(log_type, crawler, env, f"get_videoList:{r.text}\n")
                    return
                elif "data" not in r.json():
                    Common.logger(log_type, crawler).info(f"get_videoList:{r.json()}\n")
                    Common.logging(log_type, crawler, env, f"get_videoList:{r.json()}\n")
                    return
                elif "list" not in r.json()["data"]:
                    Common.logger(log_type, crawler).warning(f"get_videoList:{r.json()['data']}\n")
                    Common.logging(log_type, crawler, env, f"get_videoList:{r.json()['data']}\n")
                    return
                elif len(r.json()["data"]["list"]) == 0:
                    Common.logger(log_type, crawler).warning(f"get_videoList:{r.json()['data']['list']}\n")
                    Common.logging(log_type, crawler, env, f"get_videoList:{r.json()['data']['list']}\n")
                    return
                else:
                    # 视频列表数据
                    feeds = r.json()["data"]["list"]
                    for i in range(len(feeds)):
                        try:
                            # 标题，表情随机加在片头、片尾，或替代句子中间的标点符号
                            xiaoniangao_title = feeds[i].get("title", "").strip().replace("\n", "") \
                                .replace("/", "").replace("\r", "").replace("#", "") \
                                .replace(".", "。").replace("\\", "").replace("&NBSP", "") \
                                .replace(":", "").replace("*", "").replace("？", "") \
                                .replace("?", "").replace('"', "").replace("<", "") \
                                .replace(">", "").replace("|", "").replace(" ", "") \
                                .replace('"', '').replace("'", '')
                            # 随机取一个表情/符号
                            emoji = random.choice(get_config_from_mysql(log_type, crawler, env, "emoji"))
                            # 生成最终标题，标题list[表情+title, title+表情]随机取一个
                            video_title = random.choice([f"{emoji}{xiaoniangao_title}", f"{xiaoniangao_title}{emoji}"])
                            # 发布时间
                            publish_time_stamp = int(int(feeds[i].get("t", 0)) / 1000)
                            publish_time_str = time.strftime("%Y-%m-%d %H:%M:%S", time.localtime(publish_time_stamp))
                            # 用户名 / 头像
                            user_name = feeds[i].get("user", {}).get("nick", "").strip().replace("\n", "") \
                                .replace("/", "").replace("快手", "").replace(" ", "") \
                                .replace(" ", "").replace("&NBSP", "").replace("\r", "")

                            video_dict = {
                                "video_title": video_title,
                                "video_id": feeds[i].get("vid", ""),
                                "duration": int(feeds[i].get("du", 0) / 1000),
                                "play_cnt": feeds[i].get("play_pv", 0),
                                "like_cnt": feeds[i].get("favor", {}).get("total", 0),
                                "comment_cnt": feeds[i].get("comment_count", 0),
                                "share_cnt": feeds[i].get("share", 0),
                                "user_name": user_name,
                                "publish_time_stamp": publish_time_stamp,
                                "publish_time_str": publish_time_str,
                                "video_width": int(feeds[i].get("vw", 0)),
                                "video_height": int(feeds[i].get("vh", 0)),
                                "avatar_url": feeds[i].get("user", {}).get("hurl", ""),
                                "profile_id": feeds[i]["id"],
                                "profile_mid": feeds[i]["user"]["mid"],
                                "cover_url": feeds[i].get("url", ""),
                                "video_url": feeds[i].get("v_url", ""),
                                "session": f"xiaoniangao-play-{int(time.time())}"

                            }
                            for k, v in video_dict.items():
                                Common.logger(log_type, crawler).info(f"{k}:{v}")
                            Common.logging(log_type, crawler, env, f"{video_dict}")

                            # 过滤无效视频
                            if video_title == "" or video_dict["video_id"] == "" or video_dict["video_url"] == "":
                                Common.logger(log_type, crawler).warning("无效视频\n")
                                Common.logging(log_type, crawler, env, "无效视频\n")
                            # 抓取基础规则过滤
                            elif download_rule(log_type=log_type, crawler=crawler, video_dict=video_dict, rule_dict=rule_dict) is False:
                                Common.logger(log_type, crawler).info("不满足抓取规则\n")
                                Common.logging(log_type, crawler, env, "不满足抓取规则\n")
                            elif any(str(word) if str(word) in video_dict["video_title"] else False
                                     for word in get_config_from_mysql(log_type=log_type,
                                                                       source=crawler,
                                                                       env=env,
                                                                       text="filter",
                                                                       action="")) is True:
                                Common.logger(log_type, crawler).info('已中过滤词\n')
                                Common.logging(log_type, crawler, env, '已中过滤词\n')
                            elif cls.repeat_video(log_type, crawler, video_dict['video_id'], env) != 0:
                                Common.logger(log_type, crawler).info('视频已下载\n')
                                Common.logging(log_type, crawler, env, '视频已下载\n')
                            else:
                                # cls.download_publish(log_type=log_type,
                                #                      crawler=crawler,
                                #                      video_dict=video_dict,
                                #                      rule_dict=rule_dict,
                                #                      our_uid=our_uid,
                                #                      env=env)
                                video_dict["out_user_id"] = video_dict["profile_id"]
                                video_dict["platform"] = crawler
                                video_dict["strategy"] = log_type
                                video_dict["out_video_id"] = video_dict["video_id"]
                                video_dict["width"] = video_dict["video_width"]
                                video_dict["height"] = video_dict["video_height"]
                                video_dict["crawler_rule"] = json.dumps(rule_dict)
                                video_dict["user_id"] = our_uid
                                video_dict["publish_time"] = video_dict["publish_time_str"]
                                video_dict["strategy_type"] = "play"

                                mq.send_msg(video_dict)
                        except Exception as e:
                            Common.logger(log_type, crawler).error(f"抓取单条视频异常:{e}\n")
                            Common.logging(log_type, crawler, env, f"抓取单条视频异常:{e}\n")
            except Exception as e:
                Common.logger(log_type, crawler).error(f"抓取第{page}页时异常:{e}\n")
                Common.logging(log_type, crawler, env, f"抓取第{page}页时异常:{e}\n")

    @classmethod
    def repeat_video(cls, log_type, crawler, video_id, env):
        # sql = f""" select * from crawler_video where platform="{cls.platform}" and out_video_id="{video_id}"; """
        sql = f""" select * from crawler_video where platform in ("{crawler}","{cls.platform}") and out_video_id="{video_id}"; """
        repeat_video = MysqlHelper.get_values(log_type, crawler, sql, env)
        return len(repeat_video)

    @classmethod
    def download_publish(cls, log_type, crawler, video_dict, rule_dict, our_uid, env):
        # 下载视频
        Common.download_method(log_type=log_type, crawler=crawler, text="video", title=video_dict["video_title"], url=video_dict["video_url"])
        md_title = md5(video_dict['video_title'].encode('utf8')).hexdigest()
        try:
            if os.path.getsize(f"./{crawler}/videos/{md_title}/video.mp4") == 0:
                # 删除视频文件夹
                shutil.rmtree(f"./{crawler}/videos/{md_title}")
                Common.logger(log_type, crawler).info("视频size=0，删除成功\n")
                Common.logging(log_type, crawler, env, "视频size=0，删除成功\n")
                return
        except FileNotFoundError:
            # 删除视频文件夹
            shutil.rmtree(f"./{crawler}/videos/{md_title}")
            Common.logger(log_type, crawler).info("视频文件不存在，删除文件夹成功\n")
            Common.logging(log_type, crawler, env, "视频文件不存在，删除文件夹成功\n")
            return
        # 下载封面
        Common.download_method(log_type=log_type, crawler=crawler, text="cover", title=video_dict["video_title"], url=video_dict["cover_url"])
        # 保存视频信息至 "./videos/{download_video_title}/info.txt"
        Common.save_video_info(log_type=log_type, crawler=crawler, video_dict=video_dict)

        # 上传视频
        Common.logger(log_type, crawler).info("开始上传视频...")
        Common.logging(log_type, crawler, env, "开始上传视频...")
        if env == "dev":
            oss_endpoint = "out"
            our_video_id = Publish.upload_and_publish(log_type=log_type,
                                                      crawler=crawler,
                                                      strategy="播放量抓取策略",
                                                      our_uid=our_uid,
                                                      env=env,
                                                      oss_endpoint=oss_endpoint)
            our_video_link = f"https://testadmin.piaoquantv.com/cms/post-detail/{our_video_id}/info"
        else:
            oss_endpoint = "inner"
            our_video_id = Publish.upload_and_publish(log_type=log_type,
                                                      crawler=crawler,
                                                      strategy="播放量抓取策略",
                                                      our_uid=our_uid,
                                                      env=env,
                                                      oss_endpoint=oss_endpoint)

            our_video_link = f"https://admin.piaoquantv.com/cms/post-detail/{our_video_id}/info"

        if our_video_id is None:
            try:
                # 删除视频文件夹
                shutil.rmtree(f"./{crawler}/videos/{md_title}")
                return
            except FileNotFoundError:
                return

        insert_sql = f""" insert into crawler_video(video_id,
                                                    out_user_id,
                                                    platform,
                                                    strategy,
                                                    out_video_id,
                                                    video_title,
                                                    cover_url,
                                                    video_url,
                                                    duration,
                                                    publish_time,
                                                    play_cnt,
                                                    crawler_rule,
                                                    width,
                                                    height)
                                                    values({our_video_id},
                                                    "{video_dict['profile_id']}",
                                                    "{cls.platform}",
                                                    "播放量抓取策略",
                                                    "{video_dict['video_id']}",
                                                    "{video_dict['video_title']}",
                                                    "{video_dict['cover_url']}",
                                                    "{video_dict['video_url']}",
                                                    {int(video_dict['duration'])},
                                                    "{video_dict['publish_time_str']}",
                                                    {int(video_dict['play_cnt'])},
                                                    '{json.dumps(rule_dict)}',
                                                    {int(video_dict['video_width'])},
                                                    {int(video_dict['video_height'])}) """
        Common.logger(log_type, crawler).info(f"insert_sql:{insert_sql}")
        Common.logging(log_type, crawler, env, f"insert_sql:{insert_sql}")
        MysqlHelper.update_values(log_type, crawler, insert_sql, env)
        Common.logger(log_type, crawler).info('视频信息写入数据库成功')
        Common.logging(log_type, crawler, env, '视频信息写入数据库成功')

        # 视频写入飞书
        Feishu.insert_columns(log_type, crawler, "c85k1C", "ROWS", 1, 2)
        # 视频ID工作表，首行写入数据
        upload_time = int(time.time())
        values = [[time.strftime("%Y-%m-%d %H:%M:%S", time.localtime(upload_time)),
                   "播放量榜爬虫策略",
                   str(video_dict['video_id']),
                   str(video_dict['video_title']),
                   our_video_link,
                   video_dict['play_cnt'],
                   video_dict['comment_cnt'],
                   video_dict['like_cnt'],
                   video_dict['share_cnt'],
                   video_dict['duration'],
                   f"{video_dict['video_width']}*{video_dict['video_height']}",
                   str(video_dict['publish_time_str']),
                   str(video_dict['user_name']),
                   str(video_dict['profile_id']),
                   str(video_dict['profile_mid']),
                   str(video_dict['avatar_url']),
                   str(video_dict['cover_url']),
                   str(video_dict['video_url'])]]
        time.sleep(0.5)
        Feishu.update_values(log_type, crawler, "c85k1C", "F2:Z2", values)
        Common.logger(log_type, crawler).info('视频信息写入飞书成功\n')
        Common.logging(log_type, crawler, env, '视频信息写入飞书成功\n')


if __name__ == '__main__':

    pass
